# GoSublime [![Backers on Open Collective](https://opencollective.com/gosublime/backers/badge.svg)](#backers) [![Sponsors on Open Collective](https://opencollective.com/gosublime/sponsors/badge.svg)](#sponsors) [![Build Status](https://travis-ci.org/DisposaBoy/GoSublime.svg?branch=master)](https://travis-ci.org/DisposaBoy/GoSublime)

## Intro

GoSublime is an IDE-like plugin for [Sublime Text 3](http://www.sublimetext.com/) mainly, but not limited to, providing integration for most of your Go/Golang development tools.

See https://margo.sh/b/hello-margo/ for a brief introduction to margo, the engine behind GoSublime.

## Installation & Support

See https://margo.sh/b/migrate/ for instructions on how to install GoSublime.

See [SUPPORT.md](SUPPORT.md) for details about what level of support you can expect while using GoSublime.

## Features

- code completion from Gocode (fork);
- context aware snippets via the code-completion popup;
- sublime build system(ctrl+b) integrating with GoSublime 9o command prompt with live command output;
- lint/syntax check as you type or on save;
- quickly jump to any linter error reported in any open file or package;
- quickly fmt your source or automatically on save to conform with your coding standards;
- easily create a new go file and run it without needing to save it first (9o `replay`);
- share your snippets (anything in the loaded file) on play.golang.org;
- list declarations in the current file or package;
- automatically add/remove package imports;
- quickly jump your import section(automatically goes to the last import) where you can easily edit the pkg alias and return to where you were before;
- go to definition of a package function or constant, etc.;
- create your own margo extensions in Go to e.g. add context-aware commands to the command palette.

## Demo

- Old demo http://vimeo.com/disposaboy/gosublime-demo2

## Copyright, License & Contributors

margo and GoSublime are released under the MIT license. See [LICENSE.md](LICENSE.md)

Thanks to all the people who contribute. [[Contribute](CONTRIBUTING.md)].
<a href="graphs/contributors"><img src="https://opencollective.com/gosublime/contributors.svg?width=890" /></a>

### Supporters

GoSublime has received support from many kind individuals and as a thank you I've added most to [THANKS.md](THANKS.md) file as a way of saying _Thank You_. Some donors donated anonymously and so are not listed, however. If you have donated and would like to add an entry to this file, feel free to open a pull request.

### Donations

See https://margo.sh/funding/ for ways in which you can help support future development of margo and GoSublime.

<hr/>

Become a backer or a sponsor on OpenCollective

### Backers

Thank you to all our backers! 🙏 [[Become a backer](https://opencollective.com/gosublime#backer)]

<a href="https://opencollective.com/gosublime#backers" target="_blank"><img src="https://opencollective.com/gosublime/backers.svg?width=890"></a>

### Sponsors

Support this project by becoming a sponsor. Your logo will show up here with a link to your website. [[Become a sponsor](https://opencollective.com/gosublime#sponsor)]

<a href="https://opencollective.com/gosublime/sponsor/0/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/0/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/1/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/1/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/2/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/2/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/3/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/3/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/4/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/4/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/5/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/5/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/6/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/6/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/7/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/7/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/8/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/8/avatar.svg"></a>
<a href="https://opencollective.com/gosublime/sponsor/9/website" target="_blank"><img src="https://opencollective.com/gosublime/sponsor/9/avatar.svg"></a>

<br>

<a href="https://margo.sh/sponsors/0" target="_blank"><img src="https://margo.sh/sponsors/0.svg?2"></a>
